WITH   Ada.Unchecked_Conversion ;
WITH   Interfaces.C ;
WITH   Stdarg ;
WITH   System ;
WITH   Win32 ;
WITH   Win32.Crt.Strings ;
WITH   Win32.Windef ;
WITH   Win32.Wingdi ;
WITH   Win32.Winuser ;

PACKAGE BODY   CharTb04_Pkg  IS

   FUNCTION   CP   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPCSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPCSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CP;

   FUNCTION   CPS   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CPS;

   FUNCTION   To_IntW  IS  new Ada.Unchecked_Conversion(Win32.PCHAR, Integer);
   FUNCTION   To_PCHAR  IS  new Ada.Unchecked_Conversion(Integer, Win32.PCHAR);

   USE TYPE   Win32.CHAR_Array ;      --- To get "&"

   Nul : Win32.Char RENAMES Win32.Nul ;

   IgnoredI : Win32.INT ;
   IgnoredP : Win32.PSTR ;

   C_MainPMTitle : CONSTANT Win32.CHAR_Array := "Information"  &  Nul ;

   CRLF : CONSTANT Win32.CHAR_Array := Win32.Char(Character'Val(13))  &  Win32.Char(Character'Val(10));

   C_TitleLn1 : CONSTANT Win32.CHAR_Array := "CODE   CHAR"  &  CRLF  &  Nul ;
   C_TitleLn2 : CONSTANT Win32.CHAR_Array := "-----------"  &  CRLF  &  Nul ;
   C_NumberFmt : CONSTANT Win32.CHAR_Array := "%u"  &  Nul ;
   C_3SpacesZ : CONSTANT Win32.CHAR_Array := "   "  &  Nul ;
   CRLFz : CONSTANT Win32.CHAR_Array := Win32.Char(Character'Val(13))  &  Win32.Char(Character'Val(10))  &  Nul ;

   L_Buffer : ALIASED Win32.CHAR_Array(0..4096);
   L_Buf25  : ALIASED Win32.CHAR_Array(0..25);
   L_Buf01z : ALIASED Win32.CHAR_Array(0..1);

   PROCEDURE   ShowCharTb04  IS
      FUNCTION   "&"  IS  new Stdarg.Concat ( Win32.LONG );

      L_P : Win32.LPSTR ;
      L_TmpLen : Standard.INTEGER ;
   BEGIN
      L_Buffer(0) := Nul ;
      L_P := CPS(L_Buffer);

      IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_TitleLn1) );
      IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(C_TitleLn2) );
      L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
      L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

      L_Buf01z(1) := Nul ;

      ----- LOOP , On each char
      FOR i in 0..255 LOOP
         IgnoredI := Win32.Winuser.wvsprintf ( CPS(L_Buf25) , CP(C_NumberFmt)
                                             , Stdarg.Empty & Win32.LONG(i) );
         IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(L_Buf25) );
         IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(C_3SpacesZ) );

         L_Buf01z(0) := Win32.Char(Character'Val(i));
         IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(L_Buf01z) );

         IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );

         L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
         L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);
      END LOOP;--i

      IgnoredI := Win32.Winuser.MessageBox ( System.Null_Address
                                           , CP(L_Buffer)
                                           , CP(C_MainPMTitle)
                                           , Win32.Winuser.MB_OK or Win32.Winuser.MB_ICONEXCLAMATION );
   END ShowCharTb04;
END CharTb04_Pkg;
